"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.useDrag = useDrag;
var _useRegisteredDragSource = require("./useRegisteredDragSource");
var _useOptionalFactory = require("../useOptionalFactory");
var _useDragSourceMonitor = require("./useDragSourceMonitor");
var _useDragSourceConnector = require("./useDragSourceConnector");
var _useCollectedProps = require("../useCollectedProps");
var _connectors = require("./connectors");
var _vueDemi = require("vue-demi");
function useDrag(specArg) {
    var spec = (0, _useOptionalFactory).useOptionalFactory(specArg);
    var monitor = (0, _useDragSourceMonitor).useDragSourceMonitor();
    var connector = (0, _useDragSourceConnector).useDragSourceConnector((0, _vueDemi).computed(function() {
        return (0, _vueDemi).unref(spec).options;
    }), (0, _vueDemi).computed(function() {
        return (0, _vueDemi).unref(spec).previewOptions;
    }));
    (0, _useRegisteredDragSource).useRegisteredDragSource(spec, monitor, connector);
    return [
        (0, _useCollectedProps).useCollectedProps((0, _vueDemi).computed(function() {
            return (0, _vueDemi).unref(spec).collect || function() {
                return {};
            };
        }), monitor, connector),
        (0, _connectors).useConnectDragSource(connector, spec),
        (0, _connectors).useConnectDragPreview(connector, spec), 
    ];
}
