"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.useDropTargetConnector = useDropTargetConnector;
var _internals = require("../../internals");
var _useDragDropManager = require("../useDragDropManager");
var _vueDemi = require("vue-demi");
function useDropTargetConnector(options) {
    var manager = (0, _useDragDropManager).useDragDropManager();
    var connector = (0, _vueDemi).computed(function() {
        return new _internals.TargetConnector((0, _vueDemi).unref(manager).getBackend());
    });
    (0, _vueDemi).watchEffect(function(onCleanup) {
        connector.value.dropTargetOptions = (0, _vueDemi).unref(options) || null;
        connector.value.reconnect();
        onCleanup(function() {
            return connector.value.disconnectDropTarget();
        });
    });
    return connector;
}
