"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.registerTarget = registerTarget;
exports.registerSource = registerSource;
var _vueDemi = require("vue-demi");
function registerTarget(type, target, manager) {
    var registry = (0, _vueDemi).unref(manager).getRegistry();
    var targetId = registry.addTarget((0, _vueDemi).unref(type), (0, _vueDemi).unref(target));
    return [
        targetId,
        function() {
            return registry.removeTarget(targetId);
        }
    ];
}
function registerSource(type, source, manager) {
    var registry = manager.getRegistry();
    var sourceId = registry.addSource(type, source);
    return [
        sourceId,
        function() {
            return registry.removeSource(sourceId);
        }
    ];
}
