import { TargetConnector } from "../../internals";
import { useDragDropManager } from "../useDragDropManager";
import { computed, unref, watchEffect } from "vue-demi";
export function useDropTargetConnector(options) {
    var manager = useDragDropManager();
    var connector = computed(function() {
        return new TargetConnector(unref(manager).getBackend());
    });
    watchEffect(function(onCleanup) {
        connector.value.dropTargetOptions = unref(options) || null;
        connector.value.reconnect();
        onCleanup(function() {
            return connector.value.disconnectDropTarget();
        });
    });
    return connector;
}
