import { TargetConnector } from "../TargetConnector";
import { vi, describe, it, expect } from "vitest";
describe("TargetConnector", function() {
    it("unsubscribes drop target when clearing handler id", function() {
        var backend = {
            setup: vi.fn(),
            teardown: vi.fn(),
            connectDragSource: vi.fn(),
            connectDragPreview: vi.fn(),
            connectDropTarget: vi.fn()
        };
        var connector = new TargetConnector(backend);
        var unsubscribeDropTarget = vi.fn();
        backend.connectDropTarget.mockReturnValueOnce(unsubscribeDropTarget);
        connector.receiveHandlerId("test");
        connector.hooks.dropTarget()({});
        expect(backend.connectDropTarget).toHaveBeenCalled();
        expect(unsubscribeDropTarget).not.toHaveBeenCalled();
        backend.connectDropTarget.mockClear();
        connector.receiveHandlerId(null);
        expect(backend.connectDropTarget).not.toHaveBeenCalled();
        expect(unsubscribeDropTarget).toHaveBeenCalled();
    });
});
